var ConsolidacaoOLController = function (ScreenService, MessageService, Utilities, templateManager, General, maskEngine, ZhUtil, ZHPromise) {
    
    var self = this;
    
    this.openFiltro = function(widget) {
        var widgetFiltro = widget.container.getWidget('sup07600_consolidacaoOL_FILTER');
        
        this.defineDefaultValue(widgetFiltro);
        
        ScreenService.openPopup(widgetFiltro);
    };
    
	this.defineDefaultValue = function(widgetFiltro) {
		widgetFiltro.getField('DSSITUACAO').setValue([ "P", "C" ]);
	};
	
	this.defineDefaultNrSeq = function(field) {
	    field.widget.getField('NRSEQUCONSOL').setValue('');
	    
	    this.getNrSequConsOL(field.widget.getField('NRSEQUCONSOL'));
	};
	
	this.getNrSequConsOL = function(field) {
        var row = field.widget.currentRow;
        var cdcomprador = '_';
        
        if(row.CDCOMPRADOR) {
            row.CDCOMPRADOR.forEach(function(valor) {
                cdcomprador = cdcomprador.concat(valor.concat('_'));
            });    
        } else  {
            cdcomprador = '';
        }
        if(cdcomprador == '_') {
            cdcomprador = '';
        }
        
        var idsituacao = '_';
        
        if(row.DSSITUACAO) {
            row.DSSITUACAO.forEach(function(valor) {
                idsituacao = idsituacao.concat(valor.concat('_'));
            });
        } else {
            idsituacao = '';
        }
        if(idsituacao == '_') {
            idsituacao = '';
        }
        
        var dt_inicial = (row.INTERVAL_VALIDADE) ? row.INTERVAL_VALIDADE.start : "";
        var dt_final = (row.INTERVAL_VALIDADE) ? row.INTERVAL_VALIDADE.end : "";
        var dt_consol_ini = (row.INTERVAL_CONSOLIDACAO) ? row.INTERVAL_CONSOLIDACAO.start : "";
        var dt_consol_fin = (row.INTERVAL_CONSOLIDACAO) ? row.INTERVAL_CONSOLIDACAO.end : "";
        
        field.dataSourceFilter = [
			{ 'name': 'P_CDFILIOPELOG',  'operator': '=', 'value': row.CDFILIALOL },
			{ 'name': 'P_CDOPERADOR',    'operator': '=', 'value': cdcomprador },
			{ 'name': 'P_IDSITUCONSSOL', 'operator': '=', 'value': idsituacao },
			{ 'name': 'P_DTINICONSSOLOL','operator': '=', 'value': dt_inicial },
			{ 'name': 'P_DTFINCONSSOLOL','operator': '=', 'value': dt_final },
			{ 'name': 'P_DTCONSSOLOLINI','operator': '=', 'value': dt_consol_ini },
			{ 'name': 'P_DTCONSSOLOLFIN','operator': '=', 'value': dt_consol_fin },
			{ 'name': 'P_NRSEQUCONSOL',  'operator': '=', 'value': row.NRSEQUCONSOL }
		];
		
		field.reload();
		field.widget.activate();
    };
	
    this.getProdutoGrid = function (widget) {
		if(widget.isValid()) {
			var widgetPrinc = widget.container.getWidget('sup07600_consolidacaoOL_GRID');
			
			widgetPrinc.dataSourceFilter = dataSourceFilterProdutoGrid(widget); 
			widgetPrinc.reload().then(function() {
				ScreenService.closePopup();
				widgetPrinc.activate();
				defineStripeHeader(widget);
				
				if(widgetPrinc.dataSource.data.length > 0) {
				    widgetPrinc.getAction("excluir").isVisible = true;
				    widgetPrinc.getAction("gerarSolicitacao").isVisible = true;
				    widgetPrinc.getAction("calcularEstoque").isVisible = true;
				    widgetPrinc.getAction("incluirProduto").isVisible = true;
				    widgetPrinc.getAction("verificarConsolidacaoOL").isVisible = true;
				    
				    if(widgetPrinc.dataSource.data[0].IDSITUCONSSOL == 'C') {
    				    delete widgetPrinc.getField('QTESTUTILCONSOL').inlineEditable;
                        widgetPrinc.actions.forEach(function(action) {
                            if(action.name != 'VOLTAR_VIEW' && action.name != 'excluir' && action.name != 'cancel' && action.name != 'save') {
                                action.isVisible = false;
                            } else {
                                action.isVisible = true;
                            }
                        });    
                    } else {
                        widgetPrinc.getField('QTESTUTILCONSOL').inlineEditable  = "number";
                        widgetPrinc.actions.forEach(function(action){
                            action.isVisible = true;   
                        });
                    }
                    
                    defineActionGridEntregaVisible(widget.container.getWidget('sup07600_entregaConsOL_GRID'));
				} else {
				    widgetPrinc.getAction("excluir").isVisible = false;
				    widgetPrinc.getAction("gerarSolicitacao").isVisible = false;
				    widgetPrinc.getAction("calcularEstoque").isVisible = false;
				    widgetPrinc.getAction("incluirProduto").isVisible = false;
				    widgetPrinc.getAction("verificarConsolidacaoOL").isVisible = false;
				}
			});
		}
	};
	
	this.defineActionGridEstoqueVisible = function(widget) {
        if(widget.dataSource.data.length > 0) {
            if(widget.getParent().currentRow.IDSITUCONSSOL == 'C') {
                widget.getAction('editConsiderarEstoque').isVisible = false;
            } else {
                widget.getAction('editConsiderarEstoque').isVisible = true;
            }
        } else {
            widget.getAction('editConsiderarEstoque').isVisible = false;
        }
    };
    
    var defineActionGridEntregaVisible = function(widget) {
        if(widget.getParent().dataSource.data[0].IDSITUCONSSOL == 'C') {
            widget.getAction('entregaViaOL').isVisible = false;
        } else {
            widget.getAction('entregaViaOL').isVisible = true;
        }
    };
	
	var dataSourceFilterProdutoGrid = function(widget) {
		var filtro = [
			{
			    "name": "P_NRSEQUCONSOL",
			    "operator": "=",
			    "value": widget.currentRow.NRSEQUCONSOL || ''
			},
			{
			    "name": "P_CDFILSOLI",
			    "operator": "=",
			    "value": widget.currentRow.CDFILIOPELOG || ''
			},
			{
			    "name": "P_CDPRODINI",
			    "operator": "=",
			    "value": widget.currentRow.CDPRODINICONSOL || ''
			},
			{
			    "name": "P_CDPRODFIN",
			    "operator": "=",
			    "value": widget.currentRow.CDPRODFINCONSOL || ''
			}
		];
		return filtro;
	};
	
	var defineStripeHeader = function(widget) {
	    if(widget) {
    		var widgetStripe = widget.container.getWidget('stripeWidget');
    		
    		if(widget.currentRow.NRSEQUCONSOL) {
        		widgetStripe.getField('NRSEQUCONSOL').label = 'Consolidação: ' + widget.currentRow.NRSEQUCONSOL;
        		widgetStripe.getField('CDFILIOPELOG').label = 'Operador Logístico: ' + widget.currentRow.NMFILIOPELOG;
        		widgetStripe.getField('PERIODO').label = (widget.currentRow.DTINICONSSOLOL) ? 'Período: ' + widget.currentRow.DTINICONSSOLOL + ' até: ' + widget.currentRow.DTFINCONSSOLOL : "";
    		} else {
    		    delete widgetStripe.getField('NRSEQUCONSOL').label;
        		delete widgetStripe.getField('CDFILIOPELOG').label;
        		delete widgetStripe.getField('PERIODO').label;
    		}
	    }
	};
	
	var defineDescricaoRow = function(widget) {
	    widget.currentRow.DSESTUTIL = 'Estoque - ';
        widget.currentRow.DSVIAOL = 'Via OL - ';
    	widget.currentRow.DSVIAPONTO = 'Direta - ';
	};
	
	var defineStripeFooter = function(owner, callback) {
	    var stripeFooter  = owner.container.getWidget('sup07600_entregaConsol_STRIPE');
	    
	    stripeFooter.currentRow.SUMQTENTRCONSOL = callback.dataset.resposta[0].SUMQTENTRCONSOL ? callback.dataset.resposta[0].SUMQTENTRCONSOL.toFixed(3).replace('.', ',') : "0,000";
    	stripeFooter.currentRow.SUMQTSOLIPROD   = callback.dataset.resposta[0].SUMQTSOLIPROD ? callback.dataset.resposta[0].SUMQTSOLIPROD.toFixed(3).replace('.', ',') : "0,000";
    	stripeFooter.currentRow.SUMQTDCOMPRAR   = callback.dataset.resposta[0].SUMQTDCOMPRAR ? callback.dataset.resposta[0].SUMQTDCOMPRAR.toFixed(3).replace('.', ',') : "0,000";
	};
	
	this.openProduto = function(owner) {
		var widgetGrid    = owner.container.getWidget('sup07600_consolidacaoOL_GRID');
		var widgetSwipe   = owner.container.getWidget('sup07600_entregaConsOL_GRID');
		var widgetEstoque = owner.container.getWidget('sup07600_estoqueConsOL_GRID');
		var filterSwipe   = dataSourceFilterSwipe(widgetGrid);
		
		if(!widgetGrid.editing) {
		    widgetSwipe.dataSourceFilter = filterSwipe;
    		widgetSwipe.reload().then(function(callback) {
    		    defineDescricaoRow(widgetGrid);
    		    
    		    defineStripeFooter(owner, callback);
    		    
    		    widgetGrid.updateSwipeTip(widgetGrid.currentRow);
    		    
    			widgetEstoque.dataSourceFilter = filterSwipe;
    			widgetEstoque.reload().then(function(callback) {
        			widgetGrid.updateSwipeTip(widgetGrid.currentRow);
        		});
    		});   
		}
	};
	
	var dataSourceFilterSwipe = function(grid) {
		var nrsequconsol = grid.currentRow.NRSEQUCONSOL ? grid.currentRow.NRSEQUCONSOL : grid.dataSource.data[0].NRSEQUCONSOL;
		var cdfilsoli    = grid.currentRow.CDFILSOLI ? grid.currentRow.CDFILSOLI : grid.dataSource.data[0].CDFILSOLI;
		var cdfillan     = grid.currentRow.CDFILLAN ? grid.currentRow.CDFILLAN : grid.dataSource.data[0].CDFILLAN;
		var cdproduto    = grid.currentRow.CDPRODUTO ? grid.currentRow.CDPRODUTO : grid.dataSource.data[0].CDPRODUTO;
		
		var filterProd = [
			{
			    "name": "P_NRSEQUCONSOL",
			    "operator": "=",
			    "value": nrsequconsol ? nrsequconsol : null
			},
			{
			    "name": "P_CDFILSOLI",
			    "operator": "=",
			    "value": cdfilsoli ? cdfilsoli : null
			},  
			{
			    "name": "P_CDFILLAN",
			    "operator": "=",
			    "value": cdfillan ? cdfillan : null
			},  
			{
			    "name": "P_CDPRODUTO",
			    "operator": "=",
			    "value": cdproduto ? cdproduto : null
			}
		];
		return filterProd;
	};
	
	this.openFilialEntrega = function(owner) {
	    var widgetGrid    = owner.container.getWidget('sup07600_entregaConsOL_GRID');
		var widgetSwipe   = owner.container.getWidget('sup07600_filialConsOL_GRID');
		var widgetTabbed  = owner.container.getWidget('sup07600_filialConsOL_TABBED');
		
		widgetSwipe.dataSourceFilter = dataSourceFilterFilialEntrega(widgetGrid); 
		widgetSwipe.reload().then(function(callback) {
			ScreenService.openSwipe(widgetTabbed).then(function() {
				widgetSwipe.updateSwipeTip(widgetGrid.currentRow);
			});
		});
	};
	
	var dataSourceFilterFilialEntrega = function(grid){
		var filterProd = [
			{name: "P_NRSEQUCONSOL", value: grid.currentRow.NRSEQUCONSOL || '', operator: "="},
			{name: "P_DTENTRCONSOL", value: grid.currentRow.DTENTRCONSOL || '', operator: "="},  
			{name: "P_CDPRODESTO",	 value: grid.currentRow.CDPRODESTO	 || '', operator: "="},  
			{name: "P_CDFILIOPELOG", value: grid.currentRow.CDFILSOLI	 || '', operator: "="},
			{name: "P_CDFILLAN",	 value: grid.currentRow.CDFILLAN	 || '', operator: "="}
		];
		return filterProd;
	};
	
	this.fechaSwipe = function(widgetActivate) {
        ScreenService.closeSwipe();
        widgetActivate.activate();
    };
    
    this.backToList = function(widget) {
		 ScreenService.closeSwipe();
		 widget.list();
		 widget.activate();
	};
	
	this.salvarEstUtil = function(widget) {
	    widget.currentRow.DSMETODO = 'setQtdeEstUtl';
        if(widget.currentRow.IDAUDALTSOL == 'S'){
            widget.currentRow.DSJUSTCONSOL = 'Consolidação OL';
            defineDescricaoRow(widget);
            General.callRestEngine('opl_solicitacao#/consOLController/setQtdeEstUtl', 'Row', widget.currentRow).then(function(success) {
                widget.currentRow.QTANTESTUTIL = widget.currentRow.QTESTUTILCONSOL;
                salvaGridEditavel(widget);
            }, function (error) {
    			var errorMessage = "Timeout";
                let textContentError = '';
                if (error.data){
                    errorMessage = "ERR_GENERICO";
                    textContentError = error.data.error;
                }
                MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
    		});
        } else {
            var popupJust = widget.container.getWidget('sup07600_justificativa');
            ScreenService.openPopup(popupJust);
        }
    };
    
    this.confirmarJustificativa = function(widget) {
        if(widget.currentRow.TXJSUTIFICATIVA.length > 0){
            var widgetConsOL = widget.container.getWidget('sup07600_consolidacaoOL_GRID');
        
            if(widgetConsOL.currentRow.DSMETODO == 'setIdEntregaviaOL'){
    	        var widgetEdit = widget.container.getWidget('sup07600_entregaEdit_FORM');
                widgetEdit.currentRow.IDAUDALTSOL = widgetConsOL.currentRow.IDAUDALTSOL;
                widgetEdit.currentRow.DSJUSTCONSOL = widget.currentRow.TXJSUTIFICATIVA;
                General.callRestEngine('opl_solicitacao#/consOLController/setIdEntregaviaOL', 'Row', widgetEdit.currentRow).then(function(success) {
                    var widgetEntrega = widget.container.getWidget('sup07600_entregaConsOL_GRID');
                    widget.currentRow.TXJSUTIFICATIVA = '';
                    ScreenService.closePopup();
                    self.fechaSwipe(widgetEntrega);
                    widgetEntrega.reload();
                }, function (error) {
        			var errorMessage = "Timeout";
                    let textContentError = '';
                    if (error.data){
                        errorMessage = "ERR_GENERICO";
                        textContentError = error.data.error;
                    }
                    MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
        		});
            } else {
                if(widgetConsOL.currentRow.DSMETODO == 'setQtdeEstUtl'){
                    widgetConsOL.currentRow.DSJUSTCONSOL = widget.currentRow.TXJSUTIFICATIVA;
                    defineDescricaoRow(widgetConsOL);
                    General.callRestEngine('opl_solicitacao#/consOLController/setQtdeEstUtl', 'Row', widgetConsOL.currentRow).then(function(success) {
                        widget.currentRow.TXJSUTIFICATIVA = '';
                        ScreenService.closePopup();
                        widgetConsOL.currentRow.QTANTESTUTIL = widgetConsOL.currentRow.QTESTUTILCONSOL;
                        salvaGridEditavel(widgetConsOL);
                    }, function (error) {
            			var errorMessage = "Timeout";
                        let textContentError = '';
                        if (error.data){
                            errorMessage = "ERR_GENERICO";
                            textContentError = error.data.error;
                        }
                        MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
            		});
                } else {
                    if(widgetConsOL.currentRow.DSMETODO == 'setConsideraEstoque'){
                        var widgetEstoque = widget.container.getWidget('sup07600_estoqueConsOL_GRID');
                        widgetEstoque.currentRow.DSJUSTCONSOL = widget.currentRow.TXJSUTIFICATIVA;
                        widgetEstoque.currentRow.QTANTESTUTIL = widgetConsOL.currentRow.QTESTUTILCONSOL;
                        defineDescricaoRow(widgetEstoque);
                        General.callRestEngine('opl_solicitacao#/consOLController/setConsideraEstoque', 'Row', widgetEstoque.currentRow).then(function(success) {
                            widget.currentRow.TXJSUTIFICATIVA = '';
                            ScreenService.closePopup();
                            widget.container.getWidget('sup07600_entregaConsOL_GRID').dataSource.data = success.dataset.resposta[0];
                            widget.container.getWidget('sup07600_estoqueConsOL_GRID').dataSource.data = success.dataset.resposta[1];
                            General.widgetCancelForm(widgetEstoque);
                            self.backToList(widgetConsOL);
                            widgetConsOL.reload();
                        }, function (error) {
                			var errorMessage = "Timeout";
                            let textContentError = '';
                            if (error.data){
                                errorMessage = "ERR_GENERICO";
                                textContentError = error.data.error;
                            }
                            MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
                		});
                        
                    }
                }
            }    
        }
    };
    
    var salvaGridEditavel = function (widget) {
		widget.commitInlineEdit();
		widget.list();
		widget.editing = false;
	};
    
    this.cancelarJustificativa = function(widget) {
        widget.currentRow.TXJSUTIFICATIVA = '';
        ScreenService.closePopup();
        widget.getParent().activate();
    };
	
	this.excluirConsOL = function(widget) {
        var deferred = ZHPromise.defer();
        
        MessageService.confirmMessageByCode("EXCLUIR_SOLICI_OL").then(function(success) {
            General.callRestEngine('opl_solicitacao#/consOLController/deleteConsolidacaoOL', 'DataSet', widget.dataSource.data).then(function(success) {
                widget.reload().then(function() {
        			MessageService.showMessageByCode("EXCLUSAO_REALIZADA");
        			widget.activate();
        			defineStripeHeader(widget);
        			
        			widget.getAction("excluir").isVisible = false;
				    widget.getAction("gerarSolicitacao").isVisible = false;
				    widget.getAction("calcularEstoque").isVisible = false;
				    widget.getAction("incluirProduto").isVisible = false;
				    widget.getAction("verificarConsolidacaoOL").isVisible = false;
        		});
            }, function(error) {
				var errorMessage = "Timeout";
                let textContentError = '';
                if (error.data){
                    errorMessage = "ERR_GENERICO";
                    textContentError = error.data.error;
                }
                MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
				deferred.reject();
			});
        });
    };
    
    this.editarIdEntrega = function(widget){
		var widgetSwipe   = widget.container.getWidget('sup07600_entregaEdit_FORM');
		
		widgetSwipe.newRow();
		widgetSwipe.currentRow.NRSEQUCONSOL = widget.currentRow.NRSEQUCONSOL;
		widgetSwipe.currentRow.CDFILSOLI = widget.currentRow.CDFILSOLI;
		widgetSwipe.currentRow.CDFILLAN = widget.currentRow.CDFILLAN;
		widgetSwipe.currentRow.CDPRODUTO = widget.currentRow.CDPRODUTO;
		widgetSwipe.currentRow.CDARVPROD = widget.currentRow.CDARVPROD;
		widgetSwipe.currentRow.CDPRODESTO = widget.currentRow.CDPRODESTO;
		widgetSwipe.currentRow.QTESTOCONSOL = widget.currentRow.QTESTOCONSOL;
		widgetSwipe.currentRow.IDENTREGAVIAOL = widget.currentRow.IDENTREGAVIAOL;
		widgetSwipe.currentRow.DTENTRCONSOL = widget.currentRow.DTENTRCONSOL;
		widgetSwipe.currentRow.QTENTRCONSOL = widget.currentRow.QTENTRCONSOL;
		widgetSwipe.currentRow.QTSOLIPROD = widget.currentRow.QTSOLIPROD;
		widgetSwipe.currentRow.QTDCOMPRAR = widget.currentRow.QTDCOMPRAR;
		widgetSwipe.currentRow.NRORG = getLocalVar('NRORG');

    	General.widgetEdit(widgetSwipe);
    	widgetSwipe.backupRow = Util.clone(widgetSwipe.currentRow);
        
		ScreenService.openSwipe(widgetSwipe).then(function(){
    		widgetSwipe.fields.forEach(function(field) {
                if(field.showOnView && field.name != 'IDENTREGAVIAOL') {
                    widgetSwipe.getField(field.name).readOnly = true;
                } else {
                    if(field.name == 'IDENTREGAVIAOL'){
                        widgetSwipe.getField(field.name).readOnly = false;
                    }
                }
            });
		});
	};
	
	this.cancelarIdEntrega = function(widget) {
	    widget.fields.forEach(function(field) {
			if(field.showOnView && field.name != 'IDENTREGAVIAOL') {
				widget.getField(field.name).readOnly = true;
			} else {
				if(field.name == 'IDENTREGAVIAOL'){
					widget.getField(field.name).readOnly = false;
				}
			}
		});
		
		self.fechaSwipe(widget.container.getWidget('sup07600_entregaConsOL_GRID'));
    };
    
    
    this.salvarIdEntrega = function(widget) {
	    if(widget.currentRow.IDENTREGAVIAOL != widget.backupRow.IDENTREGAVIAOL){
	        var widgetConsOL = widget.getParent().container.getWidget('sup07600_consolidacaoOL_GRID');
            widgetConsOL.currentRow.DSMETODO = 'setIdEntregaviaOL';
            if(widgetConsOL.currentRow.IDAUDALTSOL == 'S'){
                widget.currentRow.DSJUSTCONSOL = 'Consolidação OL';
                widget.currentRow.IDAUDALTSOL = widgetConsOL.currentRow.IDAUDALTSOL;
                General.callRestEngine('opl_solicitacao#/consOLController/setIdEntregaviaOL', 'Row', widget.currentRow).then(function(success) {
                    var widgetEntrega = widget.container.getWidget('sup07600_entregaConsOL_GRID');
                    self.fechaSwipe(widgetEntrega);
                    widgetEntrega.reload();
                }, function (error) {
        			var errorMessage = "Timeout";
                    let textContentError = '';
                    if (error.data){
                        errorMessage = "ERR_GENERICO";
                        textContentError = error.data.error;
                    }
                    MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
        		});
            } else {
	            var popupJust = widget.getParent().container.getWidget('sup07600_justificativa');
                ScreenService.openPopup(popupJust);
            }	        
	    } else {
	        self.cancelarIdEntrega(widget);
	    }
    };
    
    this.setEstoque = function(widget){
        var widgetPrinc = templateManager.container.getWidget('sup07600_consolidacaoOL_GRID');	
        General.callRestEngine('/consOLController/setEstoqueConsOL','DataSet',widgetPrinc.dataSource.data).then(function(calback) {
            widgetPrinc.dataSource.data = calback.dataset.resposta;
            if(calback.dataset.resposta[0].QTESTUTILCONSOL == 0 && calback.dataset.resposta[0].IDCALESTCONSOL == 'S'){
                MessageService.showMessageByCode("OPBLOCK_NAO_HA_ESTOQUE");
            }
        });  
    };
    
    this.editConsiderarEstoque = function(widget){
        General.widgetEdit(widget);
        widget.fields.forEach(function(field) {
            if(field.showOnView && field.name != 'IDUTESTCONSOL') {
                widget.getField(field.name).readOnly = true;
            } else {
                if(field.name == 'IDUTESTCONSOL'){
                    widget.getField(field.name).readOnly = false;
                }
            }
        });
    };
    
    this.cancelarConsiderarEstoque = function(widget){
        General.widgetCancelForm(widget);
    };
    
    this.salvarConsiderarEstoque = function(widget){
        if(widget.currentRow.IDUTESTCONSOL != widget.backupRow.IDUTESTCONSOL){
            var widgetConsOL = widget.getParent().container.getWidget('sup07600_consolidacaoOL_GRID');
            widgetConsOL.currentRow.DSMETODO = 'setConsideraEstoque';
            
            widget.currentRow.DTINCLUSAO = widgetConsOL.currentRow.DTINCLUSAO;
            widget.currentRow.CDPRODINI = widgetConsOL.currentRow.CDPRODINI;
            widget.currentRow.CDPRODFIN = widgetConsOL.currentRow.CDPRODFIN;
            widget.currentRow.NRORG = getLocalVar('NRORG');
            widget.currentRow.QTANTESTUTIL = widgetConsOL.currentRow.QTESTUTILCONSOL;
            
            if(widgetConsOL.currentRow.IDAUDALTSOL == 'S'){
                widget.currentRow.DSJUSTCONSOL = 'Consolidação OL';
                defineDescricaoRow(widget);
                General.callRestEngine('opl_solicitacao#/consOLController/setConsideraEstoque', 'Row', widget.currentRow).then(function(success) {
                    widget.container.getWidget('sup07600_entregaConsOL_GRID').dataSource.data = success.dataset.resposta[0];
                    widget.container.getWidget('sup07600_estoqueConsOL_GRID').dataSource.data = success.dataset.resposta[1];
                    self.backToList(widgetConsOL);    
                    widgetConsOL.reload();
                }, function (error) {
        			var errorMessage = "Timeout";
                    let textContentError = '';
                    if (error.data){
                        errorMessage = "ERR_GENERICO";
                        textContentError = error.data.error;
                    }
                    MessageService.showMessageByCode(errorMessage, {"PARAM":textContentError});
        		});
            } else {
	            var popupJust = widget.getParent().container.getWidget('sup07600_justificativa');
                ScreenService.openPopup(popupJust);
            }
        } else {
            self.cancelarConsiderarEstoque(widget);
        }
    };
    
    this.calcularEstoque = function(widget) {
        if(Util.isEmptyOrBlank(widget.dataSource.data)) {
            MessageService.showMessageByCode("OPBLOCK_EMPTY_GRID");
        } else {
            General.callRestEngine('/consOLController/setEstoqueConsOL', 'DataSet', widget.dataSource.data).then(function(calback) {
                widget.dataSource.data = calback.dataset.resposta;
                
                ScreenService.closePopup();
                
    			widget.activate();
    			
    			widget.getAction('excluir').isVisible = true;
    			
                if(calback.dataset.resposta[0].QTESTUTILCONSOL == 0 && calback.dataset.resposta[0].IDCALESTCONSOL == 'S') {
                    MessageService.showMessageByCode("OPBLOCK_NAO_HA_ESTOQUE");
                } else {
                    MessageService.showMessageByCode("OPERACAO_SUCESSO");
                }
            }).catch(function(error) {
                MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
            });
        }
    };
    
    var dataSourceFilterSolicitacao = function(widget) {
		var filtro = [
			{name: "P_CDFILIAL",     value: widget.dataSource.data[0].CDFILSOLI || '',operator: "="},
			{name: "P_DTINI",	     value: widget.dataSource.data[0].DTINI || '',operator: "="},
			{name: "P_DTFIN",	     value: widget.dataSource.data[0].DTFIN || '',operator: "="},
			{name: "P_CDPRODUTOINI", value: widget.dataSource.data[0].CDPRODINI || '',operator: "="},
			{name: "P_CDPRODUTOFIN", value: widget.dataSource.data[0].CDPRODFIN || '',operator: "="}
		];
		return filtro;
	};
    
    this.gerarSolicitacao = function(widget) {
        if(widget.isValid()) {
			var widgetSolic = widget.container.getWidget('sup07600_Solicitacoes');
			
			widgetSolic.dataSourceFilter = dataSourceFilterSolicitacao(widget); 
			widgetSolic.reload().then(function(callback) {
			    if(callback.dataset.resposta.length > 0) {
			        ScreenService.openPopup(widgetSolic);
				    widgetSolic.activate();
			    } else {
			        self.confirmarGerarSolicitacoes(widgetSolic);
			    }
			});
		}
    };
    
    this.cancelarGerarSolicitacoes = function(widget){
        ScreenService.closePopup(); 
        widget.getParent().activate();
    };
    
    this.confirmarGerarSolicitacoes = function(widget) {
        General.callRestEngine('/geraSolicitacaoOL', 'DataSet', widget.getParent().dataSource.data).then(function(calback) {
            widget.getParent().reload().then(function() {
				ScreenService.closePopup();
				
				widget.getParent().activate();
				
				if(widget.getParent().dataSource.data[0].IDSITUCONSSOL == 'C') {
                    widget.getParent().actions.forEach(function(action) {
                        if(action.name != 'VOLTAR_VIEW' && action.name != 'excluir')
                            action.isVisible = false;
                    });
                }
				if(calback.dataset.resposta.P_ROWSAFFECT.length > 0) {
				    var rowsaffect = calback.dataset.resposta.P_ROWSAFFECT;
                    MessageService.showMessageByCode("SOLICITACAO_GERADA", {"PARAM": rowsaffect});
                } else {
                    MessageService.showMessageByCode("QTDE_ESTOQUE_DISPONIVEL");
                }
			});
        });    
    };
    
    this.incluirProduto = function(widget){
        var popupIncluir = widget.container.getWidget('sup07600_incluirProduto');
        ScreenService.openPopup(popupIncluir);
    };
    
    this.cancelarInclusaoProduto = function(widget){
        ScreenService.closePopup();
        widget.getParent().activate();
    };
    
    this.getTotalSolicitado = function(field){
		field.widget.dataSourceFilter = dataSourceFilterTotalSolicitado(field); 
		field.widget.reload().then(function(callback){
		    if(callback.dataset.resposta.length > 0){
		        field.widget.currentRow.QTDESOLICITADA = callback.dataset.resposta[0].QTSOLIPROD.toFixed(3).replace('.', ',')   || 0;   
		    } else {
                field.widget.currentRow.QTDESOLICITADA = 0;
		    }
		});
		
    };
    
    var dataSourceFilterTotalSolicitado = function(field) {
        var widgetCnsol = field.widget.container.getWidget('sup07600_consolidacaoOL_GRID');
        field.widget.currentRow.DTINICIAL = widgetCnsol.dataSource.data[0].DTINI.substr(0, 10);
        field.widget.currentRow.DTFINAL   = widgetCnsol.dataSource.data[0].DTFIN.substr(0, 10);
        field.widget.currentRow.CDFILIAL  = widgetCnsol.dataSource.data[0].CDFILSOLI;
        
		var filtro = [
			{name: "P_CDFILIAL",  value: widgetCnsol.dataSource.data[0].CDFILSOLI || '',operator: "="},
			{name: "P_DTINICIAL", value: widgetCnsol.dataSource.data[0].DTINI.substr(0, 10) || '',operator: "="},
			{name: "P_DTFINAL",	  value: widgetCnsol.dataSource.data[0].DTFIN.substr(0, 10) || '',operator: "="},
			{name: "P_CDPRODINC", value: field.widget.currentRow.CDPRODUTO || '',operator: "="}
		];
		return filtro;
	};
    
    this.confirmarInclusaoProduto = function(widget){
        if(widget.currentRow.QTDESOLICITADA <= 0){
            MessageService.showMessageByCode("OPBLOCK_NAO_QTDE_CALC");
        } else {
            widget.dataSource.data[0].CDFILIAL  = widget.getParent().dataSource.data[0].CDFILSOLI;
            widget.dataSource.data[0].CDFILLAN = widget.getParent().dataSource.data[0].CDFILLAN;
            widget.dataSource.data[0].NRSEQUCONSOL = widget.getParent().dataSource.data[0].NRSEQUCONSOL;
            widget.dataSource.data[0].DTINICIAL = widget.getParent().dataSource.data[0].DTINI.substr(0, 10);
            widget.dataSource.data[0].DTFINAL   = widget.getParent().dataSource.data[0].DTFIN.substr(0, 10);
            widget.dataSource.data[0].IDEMBESTCONSOL = widget.getParent().dataSource.data[0].IDEMBESTCONSOL;
            widget.dataSource.data[0].IDCONSPREVCONOL = widget.getParent().dataSource.data[0].IDCONSPREVCONOL;
            General.callRestEngine('/incluirProduto', 'DataSet', widget.dataSource.data).then(function(calback) {
            var widgetFilter = widget.container.getWidget('sup07600_consolidacaoOL_FILTER');
            widget.getParent().dataSourceFilter = dataSourceFilterProdutoGrid(widgetFilter); 
            widget.getParent().reload().then(function(){
				ScreenService.closePopup();
				widget.getParent().activate();
				if(widget.getParent().dataSource.data[0].IDSITUCONSSOL == 'C'){
                    widget.getParent().actions.forEach(function(action){
                        if(action.name != 'VOLTAR_VIEW' && action.name != 'excluir')
                        action.isVisible = false;
                    });    
                }
				if(calback.dataset.resposta.P_ROWSAFFECT == 'S'){
				    var nrsequconsol = widget.getParent().dataSource.data[0].NRSEQUCONSOL;
                    MessageService.showMessageByCode("SOLICITACAO_GERADA", {"PARAM": nrsequconsol});
                }else{
                    MessageService.showMessageByCode("CALC_NAO_APUROU_INF");
                }
			});
        });
        }
    };
    
    this.verificaInconsConsOL = function(widget){
		widget.dataSourceFilter = dataSourceFilterInconsistencia(widget); 
		widget.reload().then(function(callback){
		    if(callback.dataset.resposta.length > 0){
		        for(var i=0;i<callback.dataset.resposta.length; i++) {
                    callback.dataset.resposta[i].IDVERIFCONSOL = gravaMsgInconsistencia(callback.dataset.resposta[i].IDVERIFCONSOL);
                }
		        ScreenService.openPopup(widget.container.getWidget('sup07600_verificaConsolidacaoOL'));
		    } else {
                MessageService.showMessageByCode("NAO_HA_DADOS_LISTADOS");
		    }
		});
		
    };
    
    var dataSourceFilterInconsistencia = function(widget) {
		var filtro = [
			{name: "P_CDFILIOPELOG",  value:  widget.getParent().dataSource.data[0].CDFILSOLI || '',operator: "="},
			{name: "P_DTINICIAL", value: widget.getParent().dataSource.data[0].DTINI.substr(0, 10) || '',operator: "="},
			{name: "P_DTFINAL",	  value: widget.getParent().dataSource.data[0].DTFIN.substr(0, 10) || '',operator: "="},
			{name: "P_CDPRODINI", value: widget.getParent().dataSource.data[0].CDPRODINI || '',operator: "="},
			{name: "P_CDPRODFIN", value: widget.getParent().dataSource.data[0].CDPRODFIN || '',operator: "="}
		];
		return filtro;
	};
        
    var gravaMsgInconsistencia = function(resposta){
        switch(resposta) {
            case "1": return "Item de solicitação não aprovado.";
            case "2": return "Item de solicitação já consolidado.";
            case "3": return "Embalagem utilizada para compra não parametrizada para a filial OL.";
            case "4": return "Embalagem utilizada para compra inativa para a filial OL.";
            case "5": return "Item de solicitação definido para entrega direta.Item de solicitação não aprovado.";
            case "6": return "Embalagem utilizada para compra sem relacionamento com o produto do OL.";
            case "7": return "Item de solicitação sem periodicidade para a filial OL.";
            case "8": return "Item de solicitação sem embalagem ativa para compra.";
            case "9": return "Não existe marca padrão cadastrada.";
            case "0": return "Embalagem selecionada para compras relacionada com produto de compra da árvore do OL.";
            case "I": return "Item relacionado com produto do OL sem cotação válida para o período.";
            default: return "Erro!";
        }
    };
    
    this.fecharRelatorio = function(widget){
        ScreenService.closePopup();
		widget.getParent().activate();
    };
    
    
};

Configuration(function (ContextRegister) {
	ContextRegister.register('ConsolidacaoOLController', ConsolidacaoOLController);
});